=== debian/changelog ===
julia (0.4.7-6) unstable; urgency=medium

  * Use openlibm instead of libm on mips, mips64el and mipsel

 -- Graham Inggs <ginggs@debian.org>  Wed, 25 Jan 2017 07:39:32 +0200

julia (0.4.7-5) unstable; urgency=medium

  * Use openlibm instead of libm on armhf and ppc64
  * Use openblas instead of blas and lapack on mips64el and ppc64
  * Update debian/copyright
  * Do not override ARM options in Make.inc
  * Do not print warning if unable to determine host CPU name
  * Add src/*.dwo to debian/clean
  * Explicitly set USE_SYSTEM_LIBM where needed

 -- Graham Inggs <ginggs@debian.org>  Mon, 23 Jan 2017 08:29:33 +0200

julia (0.4.7-4) unstable; urgency=medium

  * Use DEB_VENDOR inplace of lsb_release -si

 -- Peter Colberg <peter@colberg.org>  Mon, 02 Jan 2017 22:28:51 -0500

julia (0.4.7-3) unstable; urgency=medium

  * Set TAGGED_RELEASE_BANNER to distribution and source package version
    (Closes: #849815)

 -- Peter Colberg <peter@colberg.org>  Sat, 31 Dec 2016 13:43:20 -0500

julia (0.4.7-2) unstable; urgency=medium

  * Ensure JULIA_CPU_CORES >= 2 to respawn test workers reaching memory limit
    (Closes: #848506)

 -- Peter Colberg <peter@colberg.org>  Tue, 20 Dec 2016 23:57:28 -0500

julia (0.4.7-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Drop install-sh-exit-status.patch, applied upstream
  * Drop verbose-build.patch since libuv is already built with V=1
  * Drop do-not-use-home-directory-in-tests.patch in favour of setting HOME
  * Drop disable-download-test.patch since wget is not actually invoked
  * Remove unused lintian override configure-generated-file-in-source
  * Add debian/gbp.conf for pristine-tar

 -- Peter Colberg <peter@colberg.org>  Sun, 18 Sep 2016 23:55:05 -0400

julia (0.4.6-1) unstable; urgency=medium

  [ Peter Colberg ]
  * New upstream release
  * Refresh patches
  * Drop unneeded build dependency on libdouble-conversion-dev
  * Bump Standards-Version to 3.9.8, no further changes

  [ Graham Inggs ]
  * Use libopenlibm instead of libm on arm64
  * Fix inconsistent use of GNU_SOURCE in embedded libuv (Closes: #748573)
  * Drop arm-rec_backtrace.patch, no longer needed since ARM ABI backport

 -- Peter Colberg <peter@colberg.org>  Thu, 23 Jun 2016 22:20:54 -0400
