=== debian/control ===
Source: julia
Priority: extra
Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
Uploaders: Peter Colberg <peter@colberg.org>, Graham Inggs <ginggs@debian.org>
Build-Depends: debhelper (>= 9.20150628),
               dpkg-dev (>= 1.16.2~),
               libarpack2-dev,
               libdsfmt-dev (>= 2.2.3),
               libfftw3-dev,
               libgmp-dev,
               libjs-mathjax,
               libmpfr-dev,
               libopenblas-dev (>= 0.2.10-1~) [amd64 arm64 armhf i386 mips64el powerpc ppc64 ppc64el],
               libopenlibm-dev (>= 0.4.1+dfsg-4~) [any-i386 any-amd64 arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el],
               libopenspecfun-dev (>= 0.4~),
               libpcre2-dev (>= 10.20-3~),
               libsuitesparse-dev (>= 1:4.4.5),
               libunwind8-dev,
               libutf8proc-dev (>= 1.3),
               llvm-3.8-dev | llvm-3.7-dev | llvm-3.6-dev,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               wget
Standards-Version: 3.9.8
Section: science
Homepage: http://julialang.org
Vcs-Git: https://anonscm.debian.org/git/pkg-julia/julia.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-julia/julia.git

Package: julia
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: julia-common (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: git
Suggests: ess (>= 12.09-1~), julia-doc
Description: high-performance programming language for technical computing
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides a complete Julia installation (JIT compiler, standard
 library, text-based user interface).

Package: julia-common
Architecture: all
Depends: ${misc:Depends}
Replaces: julia (<< 0.4.1-1~)
Breaks: julia (<< 0.4.1-1~)
Recommends: julia
Description: high-performance programming language for technical computing (common files)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package contains the Julia standard library and test suite.

Package: julia-doc
Architecture: all
Section: doc
Depends: fonts-font-awesome,
         libjs-jquery,
         libjs-mathjax,
         libjs-underscore,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: julia
Description: high-performance programming language for technical computing (documentation)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package contains the Julia manual, which describes the language and its
 standard library. It also contains example Julia programs.
